<?php
/*
  MailBeez Automatic Trigger Email Campaigns
  http://www.mailbeez.com

  Copyright (c) 2010 MailBeez
	
	inspired and in parts based on
  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

	// make path work from admin
  require_once(DIR_FS_CATALOG. 'mailhive/common/classes/mailbeez.php');	
	
	// could be in language-file
	// just easier to define it in the mailbee
	define('MAILBEEZ_SATISFACTION_TEXT_TITLE', 'Satisfaction Survey');
	
	define('MAILBEEZ_SATISFACTION_TEXT_DESCRIPTION', 'Check if your customers are happy with their purchase.<br>
	With a small picture of each product.
	<br>');
	
  class satisfaction extends mailbeez {
		// class constructor
    function satisfaction() {
			// call constructor
			mailbeez::mailbeez(); 
			
			// set some stuff:
      $this->code = 'satisfaction';
			$this->module = 'satisfaction'; // same as folder name
			$this->version = '1.1'; // float value
			$this->iteration = 1;
      $this->title = MAILBEEZ_SATISFACTION_TEXT_TITLE;
      $this->description = MAILBEEZ_SATISFACTION_TEXT_DESCRIPTION;
      $this->sort_order = MAILBEEZ_SATISFACTION_SORT_ORDER;
      $this->enabled = ((MAILBEEZ_SATISFACTION_STATUS == 'True') ? true : false);
			$this->sender = MAILBEEZ_SATISFACTION_SENDER;
			$this->sender_name = MAILBEEZ_SATISFACTION_SENDER_NAME;
			$this->status_key = 'MAILBEEZ_SATISFACTION_STATUS';
			
			//$this->icon = 'icon.png';
			
			$this->documentation_key = $this->module; // leave empty if no documentation available
			// $this->documentation_root = 'http:://yoursite.com/' // modify documentation root if necessary
			
			$this->htmlBodyTemplateResource = 'body_html.tpl'; // located in folder of this module
			$this->txtBodyTemplateResource = 'body_txt.tpl'; // located in folder of this module			
			$this->subjectTemplateResource = 'subject.tpl'; // located in folder of this module
			
			$this->htmlProductListTemplateResource = 'productlist_html.tpl'; // located in folder of this module
			$this->txtProductListResource = 'productlist_txt.tpl'; // located in folder of this module
			
			$this->audience = array();
			$this->additionalFields = array('customers_id' => '007', 'order_id' => '123456', 'htmlProductList' => 'test'); 
			// list of additional fields to show in listing with testvalues used for Test-Mail
	
    }

// class methods
    
		function getAudience() {
			global $languages_id, $language;
			
			$status = MAILBEEZ_SATISFACTION_ORDER_STATUS_ID;
			
      $date_skip = $this->dbdate(MAILBEEZ_SATISFACTION_PASSED_DAYS_SKIP);
      $date_passed = $this->dbdate(MAILBEEZ_SATISFACTION_PASSED_DAYS);
														
      $query_raw = "select c.customers_firstname, c.customers_lastname, o.orders_id, 
														o.customers_id, c.customers_email_address, o.date_purchased, s.date_added as status_date
											      from " . TABLE_ORDERS . " o, " . TABLE_CUSTOMERS . " c,  " . TABLE_ORDERS_STATUS_HISTORY . " s
											      where o.customers_id = c.customers_id
															and o.orders_id = s.orders_id
															and o.orders_status = s.orders_status_id 
											        and s.orders_status_id = '" . (int)$status . "' 
											        and s.date_added <= '" . $date_passed . "' 
											        and s.date_added > '" . $date_skip . "' 
											      order by o.orders_id ASC";
			
			//echo $query_raw ;
			
			$query = mh_db_query($query_raw);
			$customer_array = array();
			$customer_products_array = array();
			$customer_orders_array = array();
			
			// load subtemplates
			$htmlProductListTemplate = $this->loadResource($this->pathToMailbeez . $this->module. '/email/' . $this->htmlProductListTemplateResource);
			$txtProductListTemplate = $this->loadResource($this->pathToMailbeez . $this->module. '/email/' . $this->txtProductListResource);
						
			while ($orders_item = mh_db_fetch_array($query)) {
				$customer_array[$orders_item['customers_id']] = array('firstname' => $orders_item['customers_firstname'],
																												 			'lastname' => $orders_item['customers_lastname'],
				                                                			'email_address' => $orders_item['customers_email_address'],
																												 			'customers_id' => $orders_item['customers_id']);
				
				$customer_orders_array[$orders_item['customers_id']][] =  $orders_item['orders_id'];
				
				$query_products_raw = "select p.products_id, op.products_name, op.products_model, p.products_image
												from " . TABLE_ORDERS_PRODUCTS		 . " op, " . TABLE_PRODUCTS . " p
											where op.products_id = p.products_id
											  		and p.products_status = '1'
														and op.orders_id = '" . $orders_item['orders_id'] . "'";
				
				$query_products = mh_db_query($query_products_raw);
				
				while ($orders_products_item = mh_db_fetch_array($query_products)) {
					$customer_products_array[$orders_item['customers_id']][$orders_products_item['products_id']] = 
							array('products_name' => $orders_products_item['products_name'],
										'products_image' => $orders_products_item['products_image'],
										'products_model' => $orders_products_item['products_model'],
										'products_id' => $orders_products_item['products_id']);
										
					$customer_products_array[$orders_item['customers_id']][$orders_products_item['products_id']]['orders_id'][] = $orders_item['orders_id'];
				}
			}
			
			foreach( $customer_array as $customers_id => $c_array) {
				
				$htmlListOut = '';
				$txtListOut = '';
				$customer_has_products = false;
				
				if (is_array($customer_products_array[$customers_id]) ) {
					foreach( $customer_products_array[$customers_id] as $products_id => $products_array ) {
						$image = '';
						
						switch (MH_PLATFORM) {
							case 'oscommerce':
							case 'xtc':
							case 'creloaded':
								$link = mh_href_link(FILENAME_PRODUCT_REVIEWS_WRITE, 'products_id=' . $products_id , 'NONSSL', false);
								break;
							case 'zencart':
								$link = zen_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . $products_id , 'NONSSL', false);
								break;
						}

					  if (mh_not_null($products_array['products_image'])) {
						
							switch (MH_PLATFORM) {
								case 'oscommerce':
								case 'creloaded':
								case 'zencart':
									$image = mh_image(HTTP_SERVER.DIR_WS_CATALOG.DIR_WS_IMAGES . $products_array['products_image'], $products_array['products_name'], SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT, 'hspace="10" vspace="0" align="left" border="0"'); 
									break;
								case 'xtc':
									$image = mh_image(DIR_WS_INFO_IMAGES . $products_array['products_image'], $products_array['products_name'], SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT, 'hspace="10" vspace="0" align="left" border="0"'); 
									break;
							}
					  }
					
						$subTemplateVars = array('satisfaction_products_image' => $image,
												 'satisfaction_link' => $link,
												 'satisfaction_products_name' => $products_array['products_name']
																		 );
						$htmlListOut .= $this->replace_variables($htmlProductListTemplate, $subTemplateVars);
						$txtListOut  .= $this->replace_variables($txtProductListTemplate, $subTemplateVars);
						$customer_has_products = true;
					}
				}

				if ($customer_has_products == true) {
					// insert only customers with still active products
					// mandatory fields:
					// - firstname
					// - lastname
					// - email_address
					// - customers-id -> block
					
					$order_id = array_pop($customer_orders_array[$customers_id]); // get the last order_id for tracking
					
					// other keys are replaced while sending: $<key>								
	 				$this->audience[$customers_id] = array('firstname' => $customer_array[$customers_id]['firstname'],
																								 'lastname' => $customer_array[$customers_id]['lastname'],
				                                         'email_address' => $customer_array[$customers_id]['email_address'],
																								 'customers_id' => $customers_id,
																								 'order_id' => $order_id,
																								 'storename' => STORE_NAME,
																								 'storeurl' => mh_href_link(FILENAME_DEFAULT),
																								 'htmlProductList' => $htmlListOut,
																								 'txtProductList' => $txtListOut);
				}
			}
			
			/*
			print_r($customer_array);
			print_r($customer_orders_array);
			print_r($customer_products_array);

			echo '---';
			print_r($this->audience);
			*/

			return $this->audience;
		}
		
		
		
		// installation methods
		
    function keys() {
      return array('MAILBEEZ_SATISFACTION_STATUS', 'MAILBEEZ_SATISFACTION_ORDER_STATUS_ID', 'MAILBEEZ_SATISFACTION_PASSED_DAYS', 'MAILBEEZ_SATISFACTION_PASSED_DAYS_SKIP', 'MAILBEEZ_SATISFACTION_SENDER', 'MAILBEEZ_SATISFACTION_SENDER_NAME', 'MAILBEEZ_SATISFACTION_SORT_ORDER');
    }
		
		
		
    function install() {
			mh_insert_config_value(array('configuration_title' => 'Send satisfaction email', 
																	 'configuration_key' => 'MAILBEEZ_SATISFACTION_STATUS', 
																	 'configuration_value' => 'False', 
																	 'configuration_description' => 'Do you want to send satisfaction emails?', 
																	 'set_function' => 'mh_cfg_select_option(array(\'True\', \'False\'), '
																	 ));

			mh_insert_config_value(array('configuration_title' => 'Set Order Status', 
																	 'configuration_key' => 'MAILBEEZ_SATISFACTION_ORDER_STATUS_ID', 
																	 'configuration_value' => '3', 
																	 'configuration_description' => 'Set the status of orders to identify date of last order', 
																	 'set_function' => 'mh_cfg_pull_down_order_statuses(', 
																	 'use_function' => 'mh_get_order_status_name'
																	 ));
																	 

			mh_insert_config_value(array('configuration_title' => 'Set days passed', 
																	 'configuration_key' => 'MAILBEEZ_SATISFACTION_PASSED_DAYS', 
																	 'configuration_value' => '10', 
																	 'configuration_description' => 'number of days since last order', 
																	 'set_function' => ''
																	 ));
																	 
			mh_insert_config_value(array('configuration_title' => 'Set days to skip after', 
																	 'configuration_key' => 'MAILBEEZ_SATISFACTION_PASSED_DAYS_SKIP', 
																	 'configuration_value' => '20', 
																	 'configuration_description' => 'number of days after which do skip the satisfaction email', 
																	 'set_function' => ''
																	 ));
																	 
			mh_insert_config_value(array('configuration_title' => 'sender email', 
																	 'configuration_key' => 'MAILBEEZ_SATISFACTION_SENDER', 
																	 'configuration_value' => STORE_OWNER_EMAIL_ADDRESS, 
																	 'configuration_description' => 'sender email', 
																	 'set_function' => ''
																	 ));
																	 
			mh_insert_config_value(array('configuration_title' => 'sender name', 
																	 'configuration_key' => 'MAILBEEZ_SATISFACTION_SENDER_NAME', 
																	 'configuration_value' => STORE_NAME, 
																	 'configuration_description' => 'sender email', 
																	 'set_function' => ''
																	 ));
																	 																	 
			mh_insert_config_value(array('configuration_title' => 'Sort order of display.', 
																	 'configuration_key' => 'MAILBEEZ_SATISFACTION_SORT_ORDER', 
																	 'configuration_value' => '40', 
																	 'configuration_description' => 'Sort order of display. Lowest is displayed first.', 
																	 'set_function' => ''
																	 ));
    }		
  }
?>
